--- linux-linaro-3.4-2012.05-1_original/drivers/mtd/Kconfig	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/mtd/Kconfig	2014-10-23 20:22:19.978715000 +0800
@@ -74,7 +74,7 @@
 endif # MTD_REDBOOT_PARTS
 
 config MTD_CMDLINE_PARTS
-	bool "Command line partition table parsing"
+	tristate "Command line partition table parsing"
 	depends on MTD = "y"
 	---help---
 	  Allow generic configuration of the MTD partition tables via the kernel
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/net/loopback.c linux-linaro-3.4-2012.05-1_cavium/drivers/net/loopback.c
--- linux-linaro-3.4-2012.05-1_original/drivers/net/loopback.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/net/loopback.c	2014-07-29 17:28:38.819972000 +0800
@@ -79,6 +79,11 @@
 
 	skb->protocol = eth_type_trans(skb, dev);
 
+#ifdef CONFIG_PUREVU
+	skb->ip_summed = CHECKSUM_UNNECESSARY;
+	skb->pkt_type = PACKET_HOST;
+#endif
+
 	/* it's OK to use per_cpu_ptr() because BHs are off */
 	lb_stats = this_cpu_ptr(dev->lstats);
 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/spi/spi-dw.c linux-linaro-3.4-2012.05-1_cavium/drivers/spi/spi-dw.c
--- linux-linaro-3.4-2012.05-1_original/drivers/spi/spi-dw.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/spi/spi-dw.c	2014-07-29 17:28:38.819972000 +0800
@@ -18,6 +18,7 @@
  */
 
 #include <linux/dma-mapping.h>
+#include <linux/pm_runtime.h>
 #include <linux/interrupt.h>
 #include <linux/module.h>
 #include <linux/highmem.h>
@@ -27,6 +28,9 @@
 
 #include "spi-dw.h"
 
+#include <mach/nand.h>
+#include <mach/hardware.h>
+
 #ifdef CONFIG_DEBUG_FS
 #include <linux/debugfs.h>
 #endif
@@ -62,6 +66,28 @@
 	void (*cs_control)(u32 command);
 };
 
+static void cnc_spi_cs_control(u32 cmd)
+{
+	static void __iomem *regs = NULL;
+	u32 val;
+
+	if (!regs)
+		regs = ioremap_nocache(CNC1900_SMC, SZ_4K);
+
+	val = __raw_readl(regs + 0x0C);
+
+	switch (cmd) {
+	case MRST_SPI_ASSERT:
+		__raw_writel(val | FORCE_CE_LOW, regs + 0x0C);
+		break;
+	case MRST_SPI_DEASSERT:
+		__raw_writel(val & ~FORCE_CE_LOW, regs + 0x0C);
+		break;
+	default:
+		break;
+	}
+}
+
 #ifdef CONFIG_DEBUG_FS
 #define SPI_REGS_BUFSIZE	1024
 static ssize_t  spi_show_regs(struct file *file, char __user *user_buf,
@@ -158,31 +184,23 @@
 /* Return the max entries we can fill into tx fifo */
 static inline u32 tx_max(struct dw_spi *dws)
 {
-	u32 tx_left, tx_room, rxtx_gap;
+	u32 tx_left, tx_room;
 
-	tx_left = (dws->tx_end - dws->tx) / dws->n_bytes;
+	tx_left = ((dws->tx0_end - dws->tx0) + (dws->tx1_end - dws->tx1))
+			/ dws->cur_chip->n_bytes;
 	tx_room = dws->fifo_len - dw_readw(dws, DW_SPI_TXFLR);
-
-	/*
-	 * Another concern is about the tx/rx mismatch, we
-	 * though to use (dws->fifo_len - rxflr - txflr) as
-	 * one maximum value for tx, but it doesn't cover the
-	 * data which is out of tx/rx fifo and inside the
-	 * shift registers. So a control from sw point of
-	 * view is taken.
-	 */
-	rxtx_gap =  ((dws->rx_end - dws->rx) - (dws->tx_end - dws->tx))
-			/ dws->n_bytes;
-
-	return min3(tx_left, tx_room, (u32) (dws->fifo_len - rxtx_gap));
+	return min(tx_left, tx_room);
 }
 
 /* Return the max entries we should read out of rx fifo */
 static inline u32 rx_max(struct dw_spi *dws)
 {
-	u32 rx_left = (dws->rx_end - dws->rx) / dws->n_bytes;
+	u32 rx_left, rx_room;
 
-	return min(rx_left, (u32)dw_readw(dws, DW_SPI_RXFLR));
+	rx_left = ((dws->rx0_end - dws->rx0) + (dws->rx1_end - dws->rx1))
+			/ dws->cur_chip->n_bytes;
+	rx_room = dw_readw(dws, DW_SPI_RXFLR);
+	return min(rx_left, rx_room);
 }
 
 static void dw_writer(struct dw_spi *dws)
@@ -192,14 +210,27 @@
 
 	while (max--) {
 		/* Set the tx word if the transfer's original "tx" is not null */
-		if (dws->tx_end - dws->len) {
-			if (dws->n_bytes == 1)
-				txw = *(u8 *)(dws->tx);
-			else
-				txw = *(u16 *)(dws->tx);
+		if (dws->tx0 < dws->tx0_end) {
+			if (dws->tx0_end - dws->len0) {
+				if (dws->cur_chip->n_bytes == 1)
+					txw = *(u8 *)(dws->tx0);
+				else
+					txw = *(u16 *)(dws->tx0);
+			} else
+				txw = 0;
+			dw_writew(dws, DW_SPI_DR, txw);
+			dws->tx0 += dws->cur_chip->n_bytes;
+		} else {
+			if (dws->tx1_end - dws->len1) {
+				if (dws->cur_chip->n_bytes == 1)
+					txw = *(u8 *)(dws->tx1);
+				else
+					txw = *(u16 *)(dws->tx1);
+			} else
+				txw = 0;
+			dw_writew(dws, DW_SPI_DR, txw);
+			dws->tx1 += dws->cur_chip->n_bytes;
 		}
-		dw_writew(dws, DW_SPI_DR, txw);
-		dws->tx += dws->n_bytes;
 	}
 }
 
@@ -211,139 +242,26 @@
 	while (max--) {
 		rxw = dw_readw(dws, DW_SPI_DR);
 		/* Care rx only if the transfer's original "rx" is not null */
-		if (dws->rx_end - dws->len) {
-			if (dws->n_bytes == 1)
-				*(u8 *)(dws->rx) = rxw;
-			else
-				*(u16 *)(dws->rx) = rxw;
+		if (dws->rx0 < dws->rx0_end) {
+			if (dws->rx0_end - dws->len0) {
+				if (dws->cur_chip->n_bytes == 1)
+					*(u8 *)(dws->rx0) = rxw;
+				else
+					*(u16 *)(dws->rx0) = rxw;
+			}
+			dws->rx0 += dws->cur_chip->n_bytes;
+		} else {
+			if (dws->rx1_end - dws->len1) {
+				if (dws->cur_chip->n_bytes == 1)
+					*(u8 *)(dws->rx1) = rxw;
+				else
+					*(u16 *)(dws->rx1) = rxw;
+			}
+			dws->rx1 += dws->cur_chip->n_bytes;
 		}
-		dws->rx += dws->n_bytes;
 	}
 }
 
-static void *next_transfer(struct dw_spi *dws)
-{
-	struct spi_message *msg = dws->cur_msg;
-	struct spi_transfer *trans = dws->cur_transfer;
-
-	/* Move to next transfer */
-	if (trans->transfer_list.next != &msg->transfers) {
-		dws->cur_transfer =
-			list_entry(trans->transfer_list.next,
-					struct spi_transfer,
-					transfer_list);
-		return RUNNING_STATE;
-	} else
-		return DONE_STATE;
-}
-
-/*
- * Note: first step is the protocol driver prepares
- * a dma-capable memory, and this func just need translate
- * the virt addr to physical
- */
-static int map_dma_buffers(struct dw_spi *dws)
-{
-	if (!dws->cur_msg->is_dma_mapped
-		|| !dws->dma_inited
-		|| !dws->cur_chip->enable_dma
-		|| !dws->dma_ops)
-		return 0;
-
-	if (dws->cur_transfer->tx_dma)
-		dws->tx_dma = dws->cur_transfer->tx_dma;
-
-	if (dws->cur_transfer->rx_dma)
-		dws->rx_dma = dws->cur_transfer->rx_dma;
-
-	return 1;
-}
-
-/* Caller already set message->status; dma and pio irqs are blocked */
-static void giveback(struct dw_spi *dws)
-{
-	struct spi_transfer *last_transfer;
-	unsigned long flags;
-	struct spi_message *msg;
-
-	spin_lock_irqsave(&dws->lock, flags);
-	msg = dws->cur_msg;
-	dws->cur_msg = NULL;
-	dws->cur_transfer = NULL;
-	dws->prev_chip = dws->cur_chip;
-	dws->cur_chip = NULL;
-	dws->dma_mapped = 0;
-	queue_work(dws->workqueue, &dws->pump_messages);
-	spin_unlock_irqrestore(&dws->lock, flags);
-
-	last_transfer = list_entry(msg->transfers.prev,
-					struct spi_transfer,
-					transfer_list);
-
-	if (!last_transfer->cs_change && dws->cs_control)
-		dws->cs_control(MRST_SPI_DEASSERT);
-
-	msg->state = NULL;
-	if (msg->complete)
-		msg->complete(msg->context);
-}
-
-static void int_error_stop(struct dw_spi *dws, const char *msg)
-{
-	/* Stop the hw */
-	spi_enable_chip(dws, 0);
-
-	dev_err(&dws->master->dev, "%s\n", msg);
-	dws->cur_msg->state = ERROR_STATE;
-	tasklet_schedule(&dws->pump_transfers);
-}
-
-void dw_spi_xfer_done(struct dw_spi *dws)
-{
-	/* Update total byte transferred return count actual bytes read */
-	dws->cur_msg->actual_length += dws->len;
-
-	/* Move to next transfer */
-	dws->cur_msg->state = next_transfer(dws);
-
-	/* Handle end of message */
-	if (dws->cur_msg->state == DONE_STATE) {
-		dws->cur_msg->status = 0;
-		giveback(dws);
-	} else
-		tasklet_schedule(&dws->pump_transfers);
-}
-EXPORT_SYMBOL_GPL(dw_spi_xfer_done);
-
-static irqreturn_t interrupt_transfer(struct dw_spi *dws)
-{
-	u16 irq_status = dw_readw(dws, DW_SPI_ISR);
-
-	/* Error handling */
-	if (irq_status & (SPI_INT_TXOI | SPI_INT_RXOI | SPI_INT_RXUI)) {
-		dw_readw(dws, DW_SPI_TXOICR);
-		dw_readw(dws, DW_SPI_RXOICR);
-		dw_readw(dws, DW_SPI_RXUICR);
-		int_error_stop(dws, "interrupt_transfer: fifo overrun/underrun");
-		return IRQ_HANDLED;
-	}
-
-	dw_reader(dws);
-	if (dws->rx_end == dws->rx) {
-		spi_mask_intr(dws, SPI_INT_TXEI);
-		dw_spi_xfer_done(dws);
-		return IRQ_HANDLED;
-	}
-	if (irq_status & SPI_INT_TXEI) {
-		spi_mask_intr(dws, SPI_INT_TXEI);
-		dw_writer(dws);
-		/* Enable TX irq always, it will be disabled when RX finished */
-		spi_umask_intr(dws, SPI_INT_TXEI);
-	}
-
-	return IRQ_HANDLED;
-}
-
 static irqreturn_t dw_spi_irq(int irq, void *dev_id)
 {
 	struct dw_spi *dws = dev_id;
@@ -352,12 +270,16 @@
 	if (!irq_status)
 		return IRQ_NONE;
 
-	if (!dws->cur_msg) {
-		spi_mask_intr(dws, SPI_INT_TXEI);
-		return IRQ_HANDLED;
-	}
+	if (dws->transfer_handler)
+		dws->transfer_handler(dws);
+	return IRQ_HANDLED;
+}
 
-	return dws->transfer_handler(dws);
+void dw_spi_xfer_done(struct dw_spi *dws)
+{
+	dws->cur_chip = NULL;
+	if (dws->cs_control)
+		dws->cs_control(MRST_SPI_DEASSERT);
 }
 
 /* Must be called inside pump_transfers() */
@@ -367,259 +289,76 @@
 		dw_writer(dws);
 		dw_reader(dws);
 		cpu_relax();
-	} while (dws->rx_end > dws->rx);
+	} while ((dws->rx0_end > dws->rx0) || (dws->rx1_end > dws->rx1));
 
 	dw_spi_xfer_done(dws);
 }
 
-static void pump_transfers(unsigned long data)
+static int dw_spi_prepare_transfer_hardware(struct spi_master *master)
 {
-	struct dw_spi *dws = (struct dw_spi *)data;
-	struct spi_message *message = NULL;
-	struct spi_transfer *transfer = NULL;
-	struct spi_transfer *previous = NULL;
-	struct spi_device *spi = NULL;
-	struct chip_data *chip = NULL;
-	u8 bits = 0;
-	u8 imask = 0;
-	u8 cs_change = 0;
-	u16 txint_level = 0;
-	u16 clk_div = 0;
-	u32 speed = 0;
-	u32 cr0 = 0;
-
-	/* Get current state information */
-	message = dws->cur_msg;
-	transfer = dws->cur_transfer;
-	chip = dws->cur_chip;
-	spi = message->spi;
-
-	if (unlikely(!chip->clk_div))
-		chip->clk_div = dws->max_freq / chip->speed_hz;
-
-	if (message->state == ERROR_STATE) {
-		message->status = -EIO;
-		goto early_exit;
-	}
-
-	/* Handle end of message */
-	if (message->state == DONE_STATE) {
-		message->status = 0;
-		goto early_exit;
-	}
-
-	/* Delay if requested at end of transfer*/
-	if (message->state == RUNNING_STATE) {
-		previous = list_entry(transfer->transfer_list.prev,
-					struct spi_transfer,
-					transfer_list);
-		if (previous->delay_usecs)
-			udelay(previous->delay_usecs);
-	}
-
-	dws->n_bytes = chip->n_bytes;
-	dws->dma_width = chip->dma_width;
-	dws->cs_control = chip->cs_control;
-
-	dws->rx_dma = transfer->rx_dma;
-	dws->tx_dma = transfer->tx_dma;
-	dws->tx = (void *)transfer->tx_buf;
-	dws->tx_end = dws->tx + transfer->len;
-	dws->rx = transfer->rx_buf;
-	dws->rx_end = dws->rx + transfer->len;
-	dws->cs_change = transfer->cs_change;
-	dws->len = dws->cur_transfer->len;
-	if (chip != dws->prev_chip)
-		cs_change = 1;
-
-	cr0 = chip->cr0;
-
-	/* Handle per transfer options for bpw and speed */
-	if (transfer->speed_hz) {
-		speed = chip->speed_hz;
-
-		if (transfer->speed_hz != speed) {
-			speed = transfer->speed_hz;
-			if (speed > dws->max_freq) {
-				printk(KERN_ERR "MRST SPI0: unsupported"
-					"freq: %dHz\n", speed);
-				message->status = -EIO;
-				goto early_exit;
-			}
-
-			/* clk_div doesn't support odd number */
-			clk_div = dws->max_freq / speed;
-			clk_div = (clk_div + 1) & 0xfffe;
-
-			chip->speed_hz = speed;
-			chip->clk_div = clk_div;
-		}
-	}
-	if (transfer->bits_per_word) {
-		bits = transfer->bits_per_word;
-
-		switch (bits) {
-		case 8:
-		case 16:
-			dws->n_bytes = dws->dma_width = bits >> 3;
-			break;
-		default:
-			printk(KERN_ERR "MRST SPI0: unsupported bits:"
-				"%db\n", bits);
-			message->status = -EIO;
-			goto early_exit;
-		}
-
-		cr0 = (bits - 1)
-			| (chip->type << SPI_FRF_OFFSET)
-			| (spi->mode << SPI_MODE_OFFSET)
-			| (chip->tmode << SPI_TMOD_OFFSET);
-	}
-	message->state = RUNNING_STATE;
-
-	/*
-	 * Adjust transfer mode if necessary. Requires platform dependent
-	 * chipselect mechanism.
-	 */
-	if (dws->cs_control) {
-		if (dws->rx && dws->tx)
-			chip->tmode = SPI_TMOD_TR;
-		else if (dws->rx)
-			chip->tmode = SPI_TMOD_RO;
-		else
-			chip->tmode = SPI_TMOD_TO;
-
-		cr0 &= ~SPI_TMOD_MASK;
-		cr0 |= (chip->tmode << SPI_TMOD_OFFSET);
-	}
-
-	/* Check if current transfer is a DMA transaction */
-	dws->dma_mapped = map_dma_buffers(dws);
-
-	/*
-	 * Interrupt mode
-	 * we only need set the TXEI IRQ, as TX/RX always happen syncronizely
-	 */
-	if (!dws->dma_mapped && !chip->poll_mode) {
-		int templen = dws->len / dws->n_bytes;
-		txint_level = dws->fifo_len / 2;
-		txint_level = (templen > txint_level) ? txint_level : templen;
-
-		imask |= SPI_INT_TXEI | SPI_INT_TXOI | SPI_INT_RXUI | SPI_INT_RXOI;
-		dws->transfer_handler = interrupt_transfer;
-	}
-
-	/*
-	 * Reprogram registers only if
-	 *	1. chip select changes
-	 *	2. clk_div is changed
-	 *	3. control value changes
-	 */
-	if (dw_readw(dws, DW_SPI_CTRL0) != cr0 || cs_change || clk_div || imask) {
-		spi_enable_chip(dws, 0);
-
-		if (dw_readw(dws, DW_SPI_CTRL0) != cr0)
-			dw_writew(dws, DW_SPI_CTRL0, cr0);
-
-		spi_set_clk(dws, clk_div ? clk_div : chip->clk_div);
-		spi_chip_sel(dws, spi->chip_select);
-
-		/* Set the interrupt mask, for poll mode just disable all int */
-		spi_mask_intr(dws, 0xff);
-		if (imask)
-			spi_umask_intr(dws, imask);
-		if (txint_level)
-			dw_writew(dws, DW_SPI_TXFLTR, txint_level);
-
-		spi_enable_chip(dws, 1);
-		if (cs_change)
-			dws->prev_chip = chip;
-	}
-
-	if (dws->dma_mapped)
-		dws->dma_ops->dma_transfer(dws, cs_change);
-
-	if (chip->poll_mode)
-		poll_transfer(dws);
-
-	return;
-
-early_exit:
-	giveback(dws);
-	return;
+	pm_runtime_get_sync(&master->dev);
+	return 0;
 }
 
-static void pump_messages(struct work_struct *work)
+static int dw_spi_unprepare_transfer_hardware(struct spi_master *master)
 {
-	struct dw_spi *dws =
-		container_of(work, struct dw_spi, pump_messages);
-	unsigned long flags;
-
-	/* Lock queue and check for queue work */
-	spin_lock_irqsave(&dws->lock, flags);
-	if (list_empty(&dws->queue) || dws->run == QUEUE_STOPPED) {
-		dws->busy = 0;
-		spin_unlock_irqrestore(&dws->lock, flags);
-		return;
-	}
-
-	/* Make sure we are not already running a message */
-	if (dws->cur_msg) {
-		spin_unlock_irqrestore(&dws->lock, flags);
-		return;
-	}
-
-	/* Extract head of queue */
-	dws->cur_msg = list_entry(dws->queue.next, struct spi_message, queue);
-	list_del_init(&dws->cur_msg->queue);
-
-	/* Initial message state*/
-	dws->cur_msg->state = START_STATE;
-	dws->cur_transfer = list_entry(dws->cur_msg->transfers.next,
-						struct spi_transfer,
-						transfer_list);
-	dws->cur_chip = spi_get_ctldata(dws->cur_msg->spi);
-
-	/* Mark as busy and launch transfers */
-	tasklet_schedule(&dws->pump_transfers);
-
-	dws->busy = 1;
-	spin_unlock_irqrestore(&dws->lock, flags);
+	pm_runtime_put(&master->dev);
+	return 0;
 }
 
-/* spi_device use this to queue in their spi_msg */
-static int dw_spi_transfer(struct spi_device *spi, struct spi_message *msg)
+static void poll_transfer_setup(struct dw_spi *dws, struct spi_transfer *transfer)
 {
-	struct dw_spi *dws = spi_master_get_devdata(spi->master);
-	unsigned long flags;
-
-	spin_lock_irqsave(&dws->lock, flags);
-
-	if (dws->run == QUEUE_STOPPED) {
-		spin_unlock_irqrestore(&dws->lock, flags);
-		return -ESHUTDOWN;
-	}
-
-	msg->actual_length = 0;
-	msg->status = -EINPROGRESS;
-	msg->state = START_STATE;
-
-	list_add_tail(&msg->queue, &dws->queue);
+	spi_enable_chip(dws, 0);
 
-	if (dws->run == QUEUE_RUNNING && !dws->busy) {
+	spi_set_cr0(dws, dws->cur_chip->cr0);
+	spi_set_clk(dws, dws->max_freq / dws->cur_chip->speed_hz);
+	spi_chip_sel(dws, 0);
+	spi_mask_intr(dws, 0xff);
 
-		if (dws->cur_transfer || dws->cur_msg)
-			queue_work(dws->workqueue,
-					&dws->pump_messages);
-		else {
-			/* If no other data transaction in air, just go */
-			spin_unlock_irqrestore(&dws->lock, flags);
-			pump_messages(&dws->pump_messages);
-			return 0;
-		}
-	}
+	spi_enable_chip(dws, 1);
+}
 
-	spin_unlock_irqrestore(&dws->lock, flags);
+static int dw_spi_transfer_one_message(struct spi_master *master, struct spi_message *msg)
+{
+	struct dw_spi *dws = spi_master_get_devdata(master);
+	struct chip_data *chip = spi_get_ctldata(msg->spi);
+	struct spi_transfer *transfer = 
+		list_first_entry(&msg->transfers, struct spi_transfer, transfer_list);
+
+	if (dws->cur_chip != chip) {
+		dws->cur_chip = chip;
+		poll_transfer_setup(dws, transfer);
+		if (dws->cs_control)
+			dws->cs_control(MRST_SPI_ASSERT);
+	}
+
+	dws->tx0 = (void *)transfer->tx_buf;
+	dws->tx0_end = dws->tx0 + transfer->len;
+	dws->rx0 = transfer->rx_buf;
+	dws->rx0_end = dws->rx0 + transfer->len;
+	dws->len0 = transfer->len;
+
+	if (list_is_singular(&msg->transfers)) {
+		dws->tx1 = dws->rx1 = NULL;
+		dws->tx1_end = dws->rx1_end = NULL;
+		dws->len1 = 0;
+	} else {
+		struct spi_transfer *next_transfer = 
+			list_first_entry(&transfer->transfer_list, struct spi_transfer, transfer_list);
+		dws->tx1 = (void *)next_transfer->tx_buf;
+		dws->tx1_end = dws->tx1 + next_transfer->len;
+		dws->rx1 = next_transfer->rx_buf;
+		dws->rx1_end = dws->rx1 + next_transfer->len;
+		dws->len1 = next_transfer->len;
+	}
+
+	pr_debug("T0 %p %d T1 %p %d\n", dws->tx0, dws->len0, dws->tx1, dws->len1);
+	pr_debug("R0 %p %d R1 %p %d\n", dws->rx0, dws->len0, dws->rx1, dws->len1);
+	poll_transfer(dws);
+
+	msg->status = 0;
+	msg->actual_length = dws->len0 + dws->len1;
+	spi_finalize_current_message(master);
 	return 0;
 }
 
@@ -696,81 +435,6 @@
 	kfree(chip);
 }
 
-static int __devinit init_queue(struct dw_spi *dws)
-{
-	INIT_LIST_HEAD(&dws->queue);
-	spin_lock_init(&dws->lock);
-
-	dws->run = QUEUE_STOPPED;
-	dws->busy = 0;
-
-	tasklet_init(&dws->pump_transfers,
-			pump_transfers,	(unsigned long)dws);
-
-	INIT_WORK(&dws->pump_messages, pump_messages);
-	dws->workqueue = create_singlethread_workqueue(
-					dev_name(dws->master->dev.parent));
-	if (dws->workqueue == NULL)
-		return -EBUSY;
-
-	return 0;
-}
-
-static int start_queue(struct dw_spi *dws)
-{
-	unsigned long flags;
-
-	spin_lock_irqsave(&dws->lock, flags);
-
-	if (dws->run == QUEUE_RUNNING || dws->busy) {
-		spin_unlock_irqrestore(&dws->lock, flags);
-		return -EBUSY;
-	}
-
-	dws->run = QUEUE_RUNNING;
-	dws->cur_msg = NULL;
-	dws->cur_transfer = NULL;
-	dws->cur_chip = NULL;
-	dws->prev_chip = NULL;
-	spin_unlock_irqrestore(&dws->lock, flags);
-
-	queue_work(dws->workqueue, &dws->pump_messages);
-
-	return 0;
-}
-
-static int stop_queue(struct dw_spi *dws)
-{
-	unsigned long flags;
-	unsigned limit = 50;
-	int status = 0;
-
-	spin_lock_irqsave(&dws->lock, flags);
-	dws->run = QUEUE_STOPPED;
-	while ((!list_empty(&dws->queue) || dws->busy) && limit--) {
-		spin_unlock_irqrestore(&dws->lock, flags);
-		msleep(10);
-		spin_lock_irqsave(&dws->lock, flags);
-	}
-
-	if (!list_empty(&dws->queue) || dws->busy)
-		status = -EBUSY;
-	spin_unlock_irqrestore(&dws->lock, flags);
-
-	return status;
-}
-
-static int destroy_queue(struct dw_spi *dws)
-{
-	int status;
-
-	status = stop_queue(dws);
-	if (status != 0)
-		return status;
-	destroy_workqueue(dws->workqueue);
-	return 0;
-}
-
 /* Restart the controller, disable all interrupts, clean rx fifo */
 static void spi_hw_init(struct dw_spi *dws)
 {
@@ -793,6 +457,8 @@
 		dws->fifo_len = (fifo == 257) ? 0 : fifo;
 		dw_writew(dws, DW_SPI_TXFLTR, 0);
 	}
+
+	dws->fifo_len /= 2;
 }
 
 int __devinit dw_spi_add_host(struct dw_spi *dws)
@@ -810,25 +476,22 @@
 
 	dws->master = master;
 	dws->type = SSI_MOTO_SPI;
-	dws->prev_chip = NULL;
+	dws->cur_chip = NULL;
 	dws->dma_inited = 0;
 	dws->dma_addr = (dma_addr_t)(dws->paddr + 0x60);
 	snprintf(dws->name, sizeof(dws->name), "dw_spi%d",
 			dws->bus_num);
 
-	ret = request_irq(dws->irq, dw_spi_irq, IRQF_SHARED,
-			dws->name, dws);
-	if (ret < 0) {
-		dev_err(&master->dev, "can not get IRQ\n");
-		goto err_free_master;
-	}
+	dws->cs_control = cnc_spi_cs_control;
 
 	master->mode_bits = SPI_CPOL | SPI_CPHA;
 	master->bus_num = dws->bus_num;
 	master->num_chipselect = dws->num_cs;
 	master->cleanup = dw_spi_cleanup;
 	master->setup = dw_spi_setup;
-	master->transfer = dw_spi_transfer;
+	master->prepare_transfer_hardware = dw_spi_prepare_transfer_hardware;
+	master->unprepare_transfer_hardware = dw_spi_unprepare_transfer_hardware;
+	master->transfer_one_message = dw_spi_transfer_one_message;
 
 	/* Basic HW init */
 	spi_hw_init(dws);
@@ -841,18 +504,13 @@
 		}
 	}
 
-	/* Initial and start queue */
-	ret = init_queue(dws);
-	if (ret) {
-		dev_err(&master->dev, "problem initializing queue\n");
-		goto err_diable_hw;
-	}
-	ret = start_queue(dws);
-	if (ret) {
-		dev_err(&master->dev, "problem starting queue\n");
-		goto err_diable_hw;
+/*	ret = request_irq(dws->irq, dw_spi_irq, IRQF_SHARED,
+			dws->name, dws);
+	if (ret < 0) {
+		dev_err(&master->dev, "can not get IRQ\n");
+		goto err_free_master;
 	}
-
+*/
 	spi_master_set_devdata(master, dws);
 	ret = spi_register_master(master);
 	if (ret) {
@@ -864,10 +522,8 @@
 	return 0;
 
 err_queue_alloc:
-	destroy_queue(dws);
 	if (dws->dma_ops && dws->dma_ops->dma_exit)
 		dws->dma_ops->dma_exit(dws);
-err_diable_hw:
 	spi_enable_chip(dws, 0);
 	free_irq(dws->irq, dws);
 err_free_master:
@@ -879,55 +535,19 @@
 
 void __devexit dw_spi_remove_host(struct dw_spi *dws)
 {
-	int status = 0;
-
 	if (!dws)
 		return;
 	mrst_spi_debugfs_remove(dws);
 
-	/* Remove the queue */
-	status = destroy_queue(dws);
-	if (status != 0)
-		dev_err(&dws->master->dev, "dw_spi_remove: workqueue will not "
-			"complete, message memory not freed\n");
-
 	if (dws->dma_ops && dws->dma_ops->dma_exit)
 		dws->dma_ops->dma_exit(dws);
 	spi_enable_chip(dws, 0);
 	/* Disable clk */
 	spi_set_clk(dws, 0);
 	free_irq(dws->irq, dws);
-
-	/* Disconnect from the SPI framework */
-	spi_unregister_master(dws->master);
 }
 EXPORT_SYMBOL_GPL(dw_spi_remove_host);
 
-int dw_spi_suspend_host(struct dw_spi *dws)
-{
-	int ret = 0;
-
-	ret = stop_queue(dws);
-	if (ret)
-		return ret;
-	spi_enable_chip(dws, 0);
-	spi_set_clk(dws, 0);
-	return ret;
-}
-EXPORT_SYMBOL_GPL(dw_spi_suspend_host);
-
-int dw_spi_resume_host(struct dw_spi *dws)
-{
-	int ret;
-
-	spi_hw_init(dws);
-	ret = start_queue(dws);
-	if (ret)
-		dev_err(&dws->master->dev, "fail to start queue (%d)\n", ret);
-	return ret;
-}
-EXPORT_SYMBOL_GPL(dw_spi_resume_host);
-
 MODULE_AUTHOR("Feng Tang <feng.tang@intel.com>");
 MODULE_DESCRIPTION("Driver for DesignWare SPI controller core");
 MODULE_LICENSE("GPL v2");
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/spi/spi-dw.h linux-linaro-3.4-2012.05-1_cavium/drivers/spi/spi-dw.h
--- linux-linaro-3.4-2012.05-1_original/drivers/spi/spi-dw.h	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/spi/spi-dw.h	2014-07-29 17:28:38.819972000 +0800
@@ -91,7 +91,6 @@
 
 struct dw_spi {
 	struct spi_master	*master;
-	struct spi_device	*cur_dev;
 	struct device		*parent_dev;
 	enum dw_ssi_type	type;
 	char			name[16];
@@ -106,33 +105,15 @@
 	u16			bus_num;
 	u16			num_cs;		/* supported slave numbers */
 
-	/* Driver message queue */
-	struct workqueue_struct	*workqueue;
-	struct work_struct	pump_messages;
-	spinlock_t		lock;
-	struct list_head	queue;
-	int			busy;
-	int			run;
-
-	/* Message Transfer pump */
-	struct tasklet_struct	pump_transfers;
-
 	/* Current message transfer state info */
-	struct spi_message	*cur_msg;
-	struct spi_transfer	*cur_transfer;
 	struct chip_data	*cur_chip;
-	struct chip_data	*prev_chip;
-	size_t			len;
-	void			*tx;
-	void			*tx_end;
-	void			*rx;
-	void			*rx_end;
-	int			dma_mapped;
-	dma_addr_t		rx_dma;
-	dma_addr_t		tx_dma;
-	size_t			rx_map_len;
-	size_t			tx_map_len;
-	u8			n_bytes;	/* current is a 1/2 bytes op */
+
+	size_t			len0, len1;
+	void			*tx0, *tx1;
+	void			*tx0_end, *tx1_end;
+	void			*rx0, *rx1;
+	void			*rx0_end, *rx1_end;
+
 	u8			max_bits_per_word;	/* maxim is 16b */
 	u32			dma_width;
 	int			cs_change;
@@ -149,8 +130,6 @@
 	struct device		*dma_dev;
 	dma_addr_t		dma_addr; /* phy address of the Data register */
 	struct dw_spi_dma_ops	*dma_ops;
-	void			*dma_priv; /* platform relate info */
-	struct pci_dev		*dmac;
 
 	/* Bus interface info */
 	void			*priv;
@@ -184,6 +163,11 @@
 	dw_writel(dws, DW_SPI_SSIENR, (enable ? 1 : 0));
 }
 
+static inline void spi_set_cr0(struct dw_spi *dws, u32 cr0)
+{
+	dw_writel(dws, DW_SPI_CTRL0, cr0);
+}
+
 static inline void spi_set_clk(struct dw_spi *dws, u16 div)
 {
 	dw_writel(dws, DW_SPI_BAUDR, div);
@@ -197,7 +181,7 @@
 	if (dws->cs_control)
 		dws->cs_control(1);
 
-	dw_writel(dws, DW_SPI_SER, 1 << cs);
+	//dw_writel(dws, DW_SPI_SER, 1 << cs);
 }
 
 /* Disable IRQ bits */
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/android/logger.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/android/logger.c
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/android/logger.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/android/logger.c	2014-07-29 17:28:38.819972000 +0800
@@ -729,8 +729,8 @@
 };
 
 DEFINE_LOGGER_DEVICE(log_main, LOGGER_LOG_MAIN, 256*1024)
-DEFINE_LOGGER_DEVICE(log_events, LOGGER_LOG_EVENTS, 256*1024)
-DEFINE_LOGGER_DEVICE(log_radio, LOGGER_LOG_RADIO, 256*1024)
+DEFINE_LOGGER_DEVICE(log_events, LOGGER_LOG_EVENTS, 1024)
+DEFINE_LOGGER_DEVICE(log_radio, LOGGER_LOG_RADIO, 1024)
 DEFINE_LOGGER_DEVICE(log_system, LOGGER_LOG_SYSTEM, 256*1024)
 
 static struct logger_log *get_log_from_minor(int minor)
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/android/lowmemorykiller.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/android/lowmemorykiller.c
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/android/lowmemorykiller.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/android/lowmemorykiller.c	2014-07-29 17:28:38.819972000 +0800
@@ -45,7 +45,7 @@
 	6,
 	12,
 };
-static int lowmem_adj_size = 4;
+static int lowmem_adj_size = 2;
 static int lowmem_minfree[6] = {
 	3 * 512,	/* 6MB */
 	2 * 1024,	/* 8MB */
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/Kconfig linux-linaro-3.4-2012.05-1_cavium/drivers/staging/Kconfig
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/Kconfig	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/Kconfig	2014-11-28 12:39:00.572447000 +0800
@@ -134,4 +134,6 @@
 
 source "drivers/staging/alc5625/Kconfig"
 
+source "drivers/staging/mausb/Kconfig"
+
 endif # STAGING
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/Makefile linux-linaro-3.4-2012.05-1_cavium/drivers/staging/Makefile
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/Makefile	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/Makefile	2014-11-28 12:39:00.572447000 +0800
@@ -58,3 +58,4 @@
 obj-$(CONFIG_RAMSTER)		+= ramster/
 obj-$(CONFIG_USB_WPAN_HCD)	+= ozwpan/
 obj-$(CONFIG_SND_SOC_ORIGEN_ALC5625)	+= alc5625/
+obj-$(CONFIG_MAUSB) += mausb/
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/Kconfig linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/Kconfig
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/Kconfig	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/Kconfig	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,34 @@
+config MA_CORE 
+ tristate "MA USB core" 
+ ---help--- 
+ This builds ma_core module. 
+ 
+config MAUSB_HOST 
+ tristate "MA USB host" 
+ depends on MA_CORE 
+ ---help--- 
+ This builds MA USB host driver module. 
+ 
+config MAUSB_DEVICE 
+ tristate "MA USB device" 
+ depends on MA_CORE && USB_GADGET 
+ ---help--- 
+ This builds MA USB device driver module. 
+ 
+config MATCP_CORE 
+ tristate "MA USB tcp core" 
+ ---help--- 
+ This builds tcp_core module. 
+ 
+config MATCP_HOST 
+ tristate "MA USB host tcp" 
+ depends on MATCP_CORE && MAUSB_HOST
+ ---help--- 
+ This builds tcp_host module. 
+ 
+config MATCP_DEVICE 
+ tristate "MA USB device tcp" 
+ depends on MATCP_CORE && MAUSB_DEVICE
+ ---help--- 
+ This builds tcp_dev module. 
+ 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/Makefile linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/Makefile
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/Makefile	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/Makefile	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,18 @@
+obj-$(CONFIG_MA_CORE) += ma_core.o 
+ma_core-y := mausb_pkt.o mausb_tx.o mausb_msapi.o mausb_mem.o mausb_mgmt.o 
+ 
+obj-$(CONFIG_MAUSB_HOST) += mausb.o 
+mausb-y := mausb_hcd.o mausb_hub.o mausb_tx-host.o mausb_mem-host.o 
+ 
+obj-$(CONFIG_MAUSB_DEVICE) += maudc.o 
+maudc-y := mausb_udc.o mausb_tx-device.o 
+ 
+obj-$(CONFIG_MATCP_HOST) += matcp_host.o 
+matcp_host-y := mausb_tcp-host.o 
+ 
+obj-$(CONFIG_MATCP_DEVICE) += matcp_dev.o 
+matcp_dev-y := mausb_tcp-device.o 
+ 
+obj-$(CONFIG_MATCP_CORE) += matcp_core.o 
+matcp_core-y := mausb_tcp.o mausb_ioctl.o 
+ 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_const.h linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_const.h
